#include <iostream>
#include <string>
using namespace std;

struct pacijent{
string kg;
int brj;
};
struct ispis{
int o,a,b,ab;
};
 int main(){
int n,o,a,b,ab;
bool provera=false;
cin>>n>>o>>a>>b>>ab;
pacijent niz[n];
ispis krv[n];
for(int i=0;i<n;i++){
    krv[i].o=0;
    krv[i].a=0;
    krv[i].b=0;
    krv[i].ab=0;
    cin>>niz[i].kg>>niz[i].brj;

    if(niz[i].kg=="O"){
        while(niz[i].brj>krv[i].o){
            if(o>0){
                krv[i].o++;
                o--;
            }
            else break;
        }
    }
    if(niz[i].kg=="A"){
        while(niz[i].brj>krv[i].a){
            if(a>0){
                krv[i].a++;
                a--;
            }
            else break;
        }
    }
    if(niz[i].kg=="B"){
        while(niz[i].brj>krv[i].b){
            if(b>0){
                krv[i].b++;
                b--;
            }
            else break;
        }
    }
    if(niz[i].kg=="AB"){
        while(niz[i].brj>krv[i].ab){
            if(ab>0){
                krv[i].ab++;
                ab--;
            }
            else break;
        }
    }
}
for(int i=0;i<n;i++){
if(niz[i].kg=="A"&& krv[i].a<niz[i].brj){
    while(niz[i].brj>krv[i].a+krv[i].o){
        if(o>0){
            krv[i].o++;
            o--;
        }
        else break;
    }
}
if(niz[i].kg=="B"&& krv[i].b<niz[i].brj){
    while(niz[i].brj>krv[i].b+krv[i].o){
        if(o>0){
            krv[i].o++;
            o--;
        }
        else break;
    }
}
if(niz[i].kg=="AB"&& krv[i].ab<niz[i].brj){
    while(niz[i].brj>krv[i].ab+krv[i].o+krv[i].b+krv[i].a){
        if(o>0){
            krv[i].o++;
            o--;
        }
        else if(a>0){
            krv[i].a++;
            a--;
        }
        else if(b>0){
            krv[i].b++;
            b--;
        }
        else break;
    }
}
if(niz[i].brj==krv[i].ab+krv[i].o+krv[i].b+krv[i].a) provera=true;
else{
    provera=false;
    cout<<"nemoguce";
    break;
}
}
if(provera){
    cout<<"moguce"<<endl;
    for(int i=0;i<n;i++){
    cout<<krv[i].o<<" "<<krv[i].a<<" "<<krv[i].b<<" "<<krv[i].ab<<endl;
}
}
}